[oe-commits] Koen Kooi : udev-extra-rules: recipe with extra rules previously provided by udev

git version control git at git.openembedded.org
Mon May 30 12:04:30 UTC 2011


Module: meta-openembedded.git
Branch: master
Commit: 7aa7dd55db8db6ec350c743ce42eb469395a3208
URL:    http://git.openembedded.org/?p=meta-openembedded.git&a=commit;h=7aa7dd55db8db6ec350c743ce42eb469395a3208

Author: Koen Kooi <koen at dominion.thruhere.net>
Date:   Sun May 29 20:33:05 2011 +0200

udev-extra-rules: recipe with extra rules previously provided by udev

These rules had no demonstratable benefit and slow down bootup a lot

Signed-off-by: Koen Kooi <koen at dominion.thruhere.net>

---

 meta-oe/recipes-core/udev/udev-extra-rules.bb      |   33 +++++++++
 .../udev/udev-extra-rules/automount.rules          |   19 +++++
 .../udev/udev-extra-rules/autonet.rules            |   19 +++++
 .../recipes-core/udev/udev-extra-rules/local.rules |   24 +++++++
 .../udev/udev-extra-rules/mount.blacklist          |    3 +
 .../recipes-core/udev/udev-extra-rules/mount.sh    |   72 ++++++++++++++++++++
 .../recipes-core/udev/udev-extra-rules/network.sh  |   58 ++++++++++++++++
 7 files changed, 228 insertions(+), 0 deletions(-)

diff --git a/meta-oe/recipes-core/udev/udev-extra-rules.bb b/meta-oe/recipes-core/udev/udev-extra-rules.bb
new file mode 100644
index 0000000..bacf152
--- /dev/null
+++ b/meta-oe/recipes-core/udev/udev-extra-rules.bb
@@ -0,0 +1,33 @@
+DESCRIPTION = "Extra udev rules"
+LICENSE = "MIT"
+LIC_FILES_CHKSUM = "file://${COREBASE}/LICENSE;md5=3f40d7994397109285ec7b81fdeb3b58"
+
+SRC_URI = " \
+       file://automount.rules \
+       file://mount.sh \
+       file://mount.blacklist \
+       file://autonet.rules \
+       file://network.sh \
+       file://local.rules \
+"
+
+
+do_install() {
+	install -d ${D}${sysconfdir}/udev/rules.d
+
+    install -m 0644 ${WORKDIR}/automount.rules     ${D}${sysconfdir}/udev/rules.d/automount.rules
+    install -m 0644 ${WORKDIR}/autonet.rules       ${D}${sysconfdir}/udev/rules.d/autonet.rules
+    install -m 0644 ${WORKDIR}/local.rules         ${D}${sysconfdir}/udev/rules.d/local.rules
+
+    install -m 0644 ${WORKDIR}/mount.blacklist     ${D}${sysconfdir}/udev/
+
+    install -d ${D}${sysconfdir}/udev/scripts/
+
+    install -m 0755 ${WORKDIR}/mount.sh ${D}${sysconfdir}/udev/scripts/mount.sh
+    install -m 0755 ${WORKDIR}/network.sh ${D}${sysconfdir}/udev/scripts
+}
+
+FILES_${PN} = "${sysconfdir}/udev"
+RDEPENDS_${PN} = "udev"
+PACKAGE_ARCH = "all"
+
diff --git a/meta-oe/recipes-core/udev/udev-extra-rules/automount.rules b/meta-oe/recipes-core/udev/udev-extra-rules/automount.rules
new file mode 100644
index 0000000..7e844c3
--- /dev/null
+++ b/meta-oe/recipes-core/udev/udev-extra-rules/automount.rules
@@ -0,0 +1,19 @@
+# There are a number of modifiers that are allowed to be used in some
+# of the different fields. They provide the following subsitutions:
+#
+# %n the "kernel number" of the device.
+#    For example, 'sda3' has a "kernel number" of '3'
+# %e the smallest number for that name which does not matches an existing node
+# %k the kernel name for the device
+# %M the kernel major number for the device
+# %m the kernel minor number for the device
+# %b the bus id for the device
+# %c the string returned by the PROGRAM
+# %s{filename} the content of a sysfs attribute
+# %% the '%' char itself
+#
+
+# Media automounting
+SUBSYSTEM=="block", ACTION=="add"    RUN+="/etc/udev/scripts/mount.sh"
+SUBSYSTEM=="block", ACTION=="remove" RUN+="/etc/udev/scripts/mount.sh"
+
diff --git a/meta-oe/recipes-core/udev/udev-extra-rules/autonet.rules b/meta-oe/recipes-core/udev/udev-extra-rules/autonet.rules
new file mode 100644
index 0000000..19676aa
--- /dev/null
+++ b/meta-oe/recipes-core/udev/udev-extra-rules/autonet.rules
@@ -0,0 +1,19 @@
+# There are a number of modifiers that are allowed to be used in some
+# of the different fields. They provide the following subsitutions:
+#
+# %n the "kernel number" of the device.
+#    For example, 'sda3' has a "kernel number" of '3'
+# %e the smallest number for that name which does not matches an existing node
+# %k the kernel name for the device
+# %M the kernel major number for the device
+# %m the kernel minor number for the device
+# %b the bus id for the device
+# %c the string returned by the PROGRAM
+# %s{filename} the content of a sysfs attribute
+# %% the '%' char itself
+#
+
+# Handle network interface setup
+SUBSYSTEM=="net", ACTION=="add" RUN+="/etc/udev/scripts/network.sh"
+SUBSYSTEM=="net", ACTION=="remove" RUN+="/etc/udev/scripts/network.sh"
+
diff --git a/meta-oe/recipes-core/udev/udev-extra-rules/local.rules b/meta-oe/recipes-core/udev/udev-extra-rules/local.rules
new file mode 100644
index 0000000..900a05a
--- /dev/null
+++ b/meta-oe/recipes-core/udev/udev-extra-rules/local.rules
@@ -0,0 +1,24 @@
+# There are a number of modifiers that are allowed to be used in some
+# of the different fields. They provide the following subsitutions:
+#
+# %n the "kernel number" of the device.
+#    For example, 'sda3' has a "kernel number" of '3'
+# %e the smallest number for that name which does not matches an existing node
+# %k the kernel name for the device
+# %M the kernel major number for the device
+# %m the kernel minor number for the device
+# %b the bus id for the device
+# %c the string returned by the PROGRAM
+# %s{filename} the content of a sysfs attribute
+# %% the '%' char itself
+#
+
+# The first rtc device is symlinked to /dev/rtc
+KERNEL=="rtc0", SYMLINK+="rtc"
+
+#The first framebuffer is symlinked to /dev/fb
+KERNEL=="fb0",  SYMLINK+="fb"
+
+# Try and modprobe for drivers for new hardware
+ACTION=="add", DEVPATH=="/devices/*", ENV{MODALIAS}=="?*", RUN+="/sbin/modprobe $env{MODALIAS}"
+
diff --git a/meta-oe/recipes-core/udev/udev-extra-rules/mount.blacklist b/meta-oe/recipes-core/udev/udev-extra-rules/mount.blacklist
new file mode 100644
index 0000000..d3ebb17
--- /dev/null
+++ b/meta-oe/recipes-core/udev/udev-extra-rules/mount.blacklist
@@ -0,0 +1,3 @@
+/dev/loop
+/dev/ram
+/dev/mtdblock
diff --git a/meta-oe/recipes-core/udev/udev-extra-rules/mount.sh b/meta-oe/recipes-core/udev/udev-extra-rules/mount.sh
new file mode 100644
index 0000000..81bcfba
--- /dev/null
+++ b/meta-oe/recipes-core/udev/udev-extra-rules/mount.sh
@@ -0,0 +1,72 @@
+#!/bin/sh
+#
+# Called from udev
+# Attemp to mount any added block devices 
+# and remove any removed devices
+#
+
+MOUNT="/bin/mount"
+PMOUNT="/usr/bin/pmount"
+UMOUNT="/bin/umount"
+name="`basename "$DEVNAME"`"
+
+for line in `cat /etc/udev/mount.blacklist | grep -v ^#`
+do
+	if ( echo "$DEVNAME" | grep -q "$line" )
+	then
+		logger "udev/mount.sh" "[$DEVNAME] is blacklisted, ignoring"
+		exit 0
+	fi
+done
+
+automount() {	
+	! test -d "/media/$name" && mkdir -p "/media/$name"
+	
+	if ! $MOUNT -t auto -o async,relatime $DEVNAME "/media/$name"
+	then
+		#logger "mount.sh/automount" "$MOUNT -t auto $DEVNAME \"/media/$name\" failed!"
+		rm_dir "/media/$name"
+	else
+		logger "mount.sh/automount" "Auto-mount of [/media/$name] successful"
+		touch "/tmp/.automount-$name"
+	fi
+}
+	
+rm_dir() {
+	# We do not want to rm -r populated directories
+	if test "`find "$1" | wc -l | tr -d " "`" -lt 2 -a -d "$1"
+	then
+		! test -z "$1" && rm -r "$1"
+	else
+		logger "mount.sh/automount" "Not removing non-empty directory [$1]"
+	fi
+}
+
+if [ "$ACTION" = "add" ] && [ -n "$DEVNAME" ]; then
+	if [ -x "$PMOUNT" ]; then
+		$PMOUNT $DEVNAME 2> /dev/null
+	elif [ -x $MOUNT ]; then
+    		$MOUNT $DEVNAME 2> /dev/null
+	fi
+	
+	# If the device isn't mounted at this point, it isn't configured in fstab
+	# 20061107: Small correction: The rootfs partition may be called just "rootfs" and not by
+	# 	    its true device name so this would break. If the rootfs is mounted on two places
+	#	    during boot, it confuses the heck out of fsck. So Im auto-adding the root-partition
+	#	    to /etc/udev/mount.blacklist via postinst 
+
+	cat /proc/mounts | awk '{print $1}' | grep -q "^$DEVNAME$" || automount 
+	
+fi
+
+
+
+if [ "$ACTION" = "remove" ] && [ -x "$UMOUNT" ] && [ -n "$DEVNAME" ]; then
+	for mnt in `cat /proc/mounts | grep "$DEVNAME" | cut -f 2 -d " " `
+	do
+		$UMOUNT -l $mnt
+	done
+	
+	# Remove empty directories from auto-mounter
+	test -e "/tmp/.automount-$name" && rm_dir "/media/$name"
+fi
diff --git a/meta-oe/recipes-core/udev/udev-extra-rules/network.sh b/meta-oe/recipes-core/udev/udev-extra-rules/network.sh
new file mode 100644
index 0000000..182c26d
--- /dev/null
+++ b/meta-oe/recipes-core/udev/udev-extra-rules/network.sh
@@ -0,0 +1,58 @@
+#!/bin/sh
+
+# udevd does clearenv(). Export shell PATH to children.
+export PATH
+
+# Do not run when pcmcia-cs is installed
+test -x /sbin/cardctl && exit 0
+
+# We get two "add" events for hostap cards due to wifi0
+echo "$INTERFACE" | grep -q wifi && exit 0
+
+
+# Check if /etc/init.d/network has been run yet to see if we are 
+# called by starting /etc/rcS.d/S03udev and not by hotplugging a device
+#
+# At this stage, network interfaces should not be brought up
+# automatically because:
+# a)	/etc/init.d/network has not been run yet (security issue)
+# b) 	/var has not been populated yet so /etc/resolv,conf points to 
+#	oblivion, making the network unusable
+#
+
+spoofp="`grep ^spoofprotect /etc/network/options`"
+if test -z "$spoofp"
+then
+	# This is the default from /etc/init.d/network
+	spoofp_val=yes
+else
+	spoofp_val=${spoofp#spoofprotect=}
+fi
+
+test "$spoofp_val" = yes && spoofp_val=1 || spoofp_val=0
+
+# I think it is safe to assume that "lo" will always be there ;)
+if test "`cat /proc/sys/net/ipv4/conf/lo/rp_filter`" != "$spoofp_val" -a -n "$spoofp_val"
+then
+	echo "$INTERFACE" >> /dev/udev_network_queue	
+	exit 0
+fi
+
+#
+# Code taken from pcmcia-cs:/etc/pcmcia/network
+#
+
+# if this interface has an entry in /etc/network/interfaces, let ifupdown
+# handle it
+if grep -q "iface \+$INTERFACE" /etc/network/interfaces; then
+  case $ACTION in
+    add)
+    	ifconfig | grep -q "^$INTERFACE" || ifup $INTERFACE
+    	;;
+    remove)
+    	ifdown $INTERFACE
+    	;;
+  esac
+  
+  exit 0
+fi





More information about the Openembedded-commits mailing list